%global         gem_name ruby-shadow

Name:           rubygem-%{gem_name}
Version:        2.5.1
Release:    1%{?dist}
Summary:        Ruby shadow password module
License:        Public Domain
URL:            https://github.com/apalmblad/ruby-shadow
Source0:        http://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:        https://raw.githubusercontent.com/apalmblad/ruby-shadow/master/test/basic_test.rb
Patch0:         ruby-shadow-2.5.1-cflags.patch
Patch1:         ruby-shadow-2.5.1-taintedness-ruby32-removal.patch
Patch2:         ruby-shadow-2.5.1-extconf-ruby32-fix.patch
BuildRequires:  gcc
BuildRequires:  ruby(release)
BuildRequires:  rubygems-devel
BuildRequires:  ruby-devel
BuildRequires:  rubygem(minitest)
BuildRequires:  rubygem(test-unit)
Provides:       ruby-shadow = %{version}-%{release}
Provides:       ruby(shadow) = %{version}
%description
This module provides access to shadow passwords on Linux and Solaris.

%package        doc
Summary:        Documentation for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch
%description    doc
Documentation for %{name}.

%prep
%setup -q  -n  %{gem_name}-%{version}
%patch1 -p1
%patch2 -p1
%patch0 -p1
cp %{SOURCE1} .

%build
export CONFIGURE_ARGS="--with-cflags='%{optflags} -Werror=implicit-function-declaration'"
gem build ../%{gem_name}-%{version}.gemspec

%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

find %{buildroot}%{gem_dir}/ -name \*.so -delete

mkdir -p %{buildroot}%{gem_extdir_mri}
cp -a .%{gem_extdir_mri}/{gem.build_complete,*.so} %{buildroot}%{gem_extdir_mri}/

rm -rf %{buildroot}%{gem_instdir}/ext/

%check
cp %{SOURCE1} .%{gem_instdir}
pushd .%{gem_instdir}
if [ $(id -u) = 0 ]; then
    ruby -I. -e 'Dir.glob "*_test.rb", &method(:require)'
else
    ruby -I. -e 'Dir.glob "*_test.rb", &method(:require)' || :
fi
popd

%files
%dir %{gem_instdir}
%{gem_extdir_mri}
%{gem_instdir}/%{gem_name}.gemspec
%exclude %{gem_instdir}/.*
%license %{gem_instdir}/LICENSE
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%exclude %{gem_instdir}/*
%doc %{gem_instdir}/HISTORY
%doc %{gem_instdir}/README
%doc %{gem_instdir}/README.euc

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.5.1-1
- initial build
